Liferay.Loader.define("segments-web@2.0.29/js/components/criteria_builder/Conjunction.es", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/drop-down', '@frontend-taglib-clay$clayui/icon', 'frontend-js-react-web$classnames', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', '../../utils/types.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

    var _dropDown = _interopRequireDefault(require("@frontend-taglib-clay$clayui/drop-down"));

    var _icon = _interopRequireDefault(require("@frontend-taglib-clay$clayui/icon"));

    var _classnames = _interopRequireDefault(require("frontend-js-react-web$classnames"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _types = require("../../utils/types.es");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function Conjunction(_ref) {
      var className = _ref.className,
          conjunctionName = _ref.conjunctionName,
          editing = _ref.editing,
          onSelect = _ref.onSelect,
          _ref$supportedConjunc = _ref.supportedConjunctions,
          supportedConjunctions = _ref$supportedConjunc === void 0 ? [] : _ref$supportedConjunc;

      var _useState = (0, _react.useState)(false),
          _useState2 = _slicedToArray(_useState, 2),
          active = _useState2[0],
          setActive = _useState2[1];

      var classnames = (0, _classnames.default)({
        'conjunction-button': editing,
        'conjunction-label': !editing
      }, className);

      var _useState3 = (0, _react.useState)(null),
          _useState4 = _slicedToArray(_useState3, 2),
          activeLabel = _useState4[0],
          setActiveLabel = _useState4[1];

      (0, _react.useEffect)(function () {
        var selectedConjunction = supportedConjunctions.find(function (c) {
          return c.name === conjunctionName;
        });
        setActiveLabel(selectedConjunction.label);
      }, [conjunctionName, supportedConjunctions]);

      function _handleItemClick(conjunctionName) {
        setActive(false);
        onSelect(conjunctionName);
      }

      return editing ? /*#__PURE__*/_react.default.createElement(_dropDown.default, {
        active: active,
        className: classnames,
        onActiveChange: setActive,
        trigger: /*#__PURE__*/_react.default.createElement(_button.default, {
          className: "text-capitalize",
          displayType: "secondary",
          small: true
        }, activeLabel, /*#__PURE__*/_react.default.createElement(_icon.default, {
          className: "ml-2",
          symbol: "caret-bottom"
        }))
      }, /*#__PURE__*/_react.default.createElement(_dropDown.default.ItemList, null, supportedConjunctions.map(function (conjunction) {
        return (/*#__PURE__*/_react.default.createElement(_dropDown.default.Item, {
            className: "text-capitalize",
            key: conjunction.name,
            onClick: function onClick() {
              return _handleItemClick(conjunction.name);
            }
          }, conjunction.label)
        );
      }))) : /*#__PURE__*/_react.default.createElement("div", {
        className: classnames
      }, activeLabel);
    }

    var _default = Conjunction;
    exports.default = _default;
    //# sourceMappingURL=Conjunction.es.js.map
  }
});
//# sourceMappingURL=Conjunction.es.js.map