Liferay.Loader.define("segments-web@2.0.29/js/components/criteria_sidebar/CriteriaSidebar.es", ['module', 'exports', 'require', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', '../../utils/types.es', './CriteriaSidebarCollapse.es', './CriteriaSidebarSearchBar.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _types = require("../../utils/types.es");

    var _CriteriaSidebarCollapse = _interopRequireDefault(require("./CriteriaSidebarCollapse.es"));

    var _CriteriaSidebarSearchBar = _interopRequireDefault(require("./CriteriaSidebarSearchBar.es"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }return _assertThisInitialized(self);
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };return _getPrototypeOf(o);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }return self;
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;return o;
      };return _setPrototypeOf(o, p);
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    var CriteriaSidebar = /*#__PURE__*/function (_Component) {
      _inherits(CriteriaSidebar, _Component);

      function CriteriaSidebar() {
        var _getPrototypeOf2;

        var _this;

        _classCallCheck(this, CriteriaSidebar);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(CriteriaSidebar)).call.apply(_getPrototypeOf2, [this].concat(args)));

        _defineProperty(_assertThisInitialized(_this), "state", {
          searchValue: ''
        });

        _defineProperty(_assertThisInitialized(_this), "_handleOnSearchChange", function (value) {
          _this.setState({
            searchValue: value
          });
        });

        return _this;
      }

      _createClass(CriteriaSidebar, [{
        key: "render",
        value: function render() {
          var _this$props = this.props,
              onTitleClicked = _this$props.onTitleClicked,
              propertyGroups = _this$props.propertyGroups,
              propertyKey = _this$props.propertyKey;
          var searchValue = this.state.searchValue;
          return (/*#__PURE__*/_react.default.createElement("div", {
              className: "criteria-sidebar-root"
            }, /*#__PURE__*/_react.default.createElement("div", {
              className: "sidebar-header"
            }, Liferay.Language.get('properties')), /*#__PURE__*/_react.default.createElement("div", {
              className: "sidebar-search"
            }, /*#__PURE__*/_react.default.createElement(_CriteriaSidebarSearchBar.default, {
              onChange: this._handleOnSearchChange,
              searchValue: searchValue
            })), /*#__PURE__*/_react.default.createElement("div", {
              className: "sidebar-collapse"
            }, /*#__PURE__*/_react.default.createElement(_CriteriaSidebarCollapse.default, {
              onCollapseClick: onTitleClicked,
              propertyGroups: propertyGroups,
              propertyKey: propertyKey,
              searchValue: searchValue
            })))
          );
        }
      }]);

      return CriteriaSidebar;
    }(_react.Component);

    var _default = CriteriaSidebar;
    exports.default = _default;
    //# sourceMappingURL=CriteriaSidebar.es.js.map
  }
});
//# sourceMappingURL=CriteriaSidebar.es.js.map