Liferay.Loader.define("segments-web@2.0.29/js/components/criteria_sidebar/CriteriaSidebarItem.es", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/icon', 'frontend-js-react-web$classnames', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', 'frontend-js-react-web$react-dnd', '../../utils/constants.es', '../../utils/drag-types.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _icon = _interopRequireDefault(require("@frontend-taglib-clay$clayui/icon"));

    var _classnames = _interopRequireDefault(require("frontend-js-react-web$classnames"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _reactDnd = require("frontend-js-react-web$react-dnd");

    var _constants = require("../../utils/constants.es");

    var _dragTypes = require("../../utils/drag-types.es");

    var _TYPE_ICON_MAP;

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }return _assertThisInitialized(self);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }return self;
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };return _getPrototypeOf(o);
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;return o;
      };return _setPrototypeOf(o, p);
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    var TYPE_ICON_MAP = (_TYPE_ICON_MAP = {}, _defineProperty(_TYPE_ICON_MAP, _constants.PROPERTY_TYPES.BOOLEAN, 'check-circle'), _defineProperty(_TYPE_ICON_MAP, _constants.PROPERTY_TYPES.COLLECTION, 'table'), _defineProperty(_TYPE_ICON_MAP, _constants.PROPERTY_TYPES.DATE, 'date'), _defineProperty(_TYPE_ICON_MAP, _constants.PROPERTY_TYPES.DATE_TIME, 'date'), _defineProperty(_TYPE_ICON_MAP, _constants.PROPERTY_TYPES.DOUBLE, 'decimal'), _defineProperty(_TYPE_ICON_MAP, _constants.PROPERTY_TYPES.ID, 'diagram'), _defineProperty(_TYPE_ICON_MAP, _constants.PROPERTY_TYPES.INTEGER, 'integer'), _defineProperty(_TYPE_ICON_MAP, _constants.PROPERTY_TYPES.STRING, 'text'), _TYPE_ICON_MAP);
    /**
     * Passes the required values to the drop target.
     * This method must be called `beginDrag`.
     * @param {Object} props Component's current props
     * @returns {Object} The props to be passed to the drop target.
     */

    function beginDrag(_ref) {
      var defaultValue = _ref.defaultValue,
          name = _ref.name,
          propertyKey = _ref.propertyKey,
          type = _ref.type;
      return {
        criterion: {
          defaultValue: defaultValue,
          propertyName: name,
          type: type
        },
        propertyKey: propertyKey
      };
    }

    var CriteriaSidebarItem = /*#__PURE__*/function (_Component) {
      _inherits(CriteriaSidebarItem, _Component);

      function CriteriaSidebarItem() {
        _classCallCheck(this, CriteriaSidebarItem);

        return _possibleConstructorReturn(this, _getPrototypeOf(CriteriaSidebarItem).apply(this, arguments));
      }

      _createClass(CriteriaSidebarItem, [{
        key: "render",
        value: function render() {
          var _this$props = this.props,
              className = _this$props.className,
              connectDragSource = _this$props.connectDragSource,
              dragging = _this$props.dragging,
              label = _this$props.label,
              type = _this$props.type;
          var classes = (0, _classnames.default)('criteria-sidebar-item-root', {
            dragging: dragging
          }, className);
          return connectDragSource( /*#__PURE__*/_react.default.createElement("li", {
            className: classes
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: "inline-item"
          }, /*#__PURE__*/_react.default.createElement(_icon.default, {
            symbol: "drag"
          })), /*#__PURE__*/_react.default.createElement("span", {
            className: "criteria-sidebar-item-type sticker sticker-light"
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: "inline-item"
          }, /*#__PURE__*/_react.default.createElement(_icon.default, {
            symbol: TYPE_ICON_MAP[type] || 'text'
          }))), label));
        }
      }]);

      return CriteriaSidebarItem;
    }(_react.Component);

    var _default = (0, _reactDnd.DragSource)(_dragTypes.DragTypes.PROPERTY, {
      beginDrag: beginDrag
    }, function (connect, monitor) {
      return {
        connectDragSource: connect.dragSource(),
        dragging: monitor.isDragging()
      };
    })(CriteriaSidebarItem);

    exports.default = _default;
    //# sourceMappingURL=CriteriaSidebarItem.es.js.map
  }
});
//# sourceMappingURL=CriteriaSidebarItem.es.js.map