Liferay.Loader.define("segments-web@2.0.29/js/components/inputs/DecimalInput.es", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/form', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _form = require("@frontend-taglib-clay$clayui/form");

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }return _assertThisInitialized(self);
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };return _getPrototypeOf(o);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }return self;
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;return o;
      };return _setPrototypeOf(o, p);
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    var DecimalInput = /*#__PURE__*/function (_React$Component) {
      _inherits(DecimalInput, _React$Component);

      function DecimalInput() {
        var _getPrototypeOf2;

        var _this;

        _classCallCheck(this, DecimalInput);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(DecimalInput)).call.apply(_getPrototypeOf2, [this].concat(args)));

        _defineProperty(_assertThisInitialized(_this), "_handleDecimalBlur", function (event) {
          var value = Number.parseFloat(event.target.value).toFixed(2);

          _this.props.onChange({
            value: value
          });
        });

        _defineProperty(_assertThisInitialized(_this), "_handleDecimalChange", function (event) {
          _this.props.onChange({
            value: event.target.value
          });
        });

        return _this;
      }

      _createClass(DecimalInput, [{
        key: "render",
        value: function render() {
          var _this$props = this.props,
              disabled = _this$props.disabled,
              options = _this$props.options,
              value = _this$props.value;
          return options.length === 0 ? /*#__PURE__*/_react.default.createElement("input", {
            className: "criterion-input form-control",
            "data-testid": "decimal-number",
            disabled: disabled,
            onBlur: this._handleDecimalBlur,
            onChange: this._handleDecimalChange,
            step: "0.01",
            type: "number",
            value: value
          }) : /*#__PURE__*/_react.default.createElement(_form.ClaySelectWithOption, {
            className: "criterion-input form-control",
            "data-testid": "options-decimal",
            disabled: disabled,
            onChange: this._handleDecimalChange,
            options: options.map(function (o) {
              return {
                disabled: o.disabled,
                label: o.label,
                value: o.value
              };
            }),
            value: value
          });
        }
      }]);

      return DecimalInput;
    }(_react.default.Component);

    _defineProperty(DecimalInput, "defaultProps", {
      options: []
    });

    var _default = DecimalInput;
    exports.default = _default;
    //# sourceMappingURL=DecimalInput.es.js.map
  }
});
//# sourceMappingURL=DecimalInput.es.js.map